#!/usr/bin/perl -w
#
# This takes 3 arguments:
#    Monitor Id
#    Deactivate pattern
#    Activate pattern
#
# Any Zones that begin with the "Deactivate pattern" will
# be set to "Inactive" and any that begin with the "Activate
# pattern" will be set to Active. So if you have a set of
# nighttime zones called "Night-NW", "Night-N", "Night-NE"
# etc and daytime zones called "Day-NW", "Day-N", "Day-NE"
# etc on monitor "3" then the following command will disable
# the "Night" zones and enable the "Day" zones.
#
# ./zm-modeswitch 3 Night Day
#
#
use DBI;

$DBschema   = "zm";             # The ZoneMinder Schema
$DBuser     = "zmuser";       # Database user
$DBpassword = "zmpass";         # Database password
$DBhostname = "localhost";      # Location of database
$ZMuser     = "admin";          # ZoneMinder user
$ZMpassword = "";               # ZoneMinder Password
$zmu        = "/usr/bin/zmu";   # Location of zmu app.

#
# Connect to the database
#
$dbh = DBI->connect("DBI:mysql:database=$DBschema;host=$DBhostname",$DBuser,$DBpassword)
       or die "Unable to connect to database $DBschema on $DBhostname";

#
# Get the arguments
#
if( @ARGV == 3 ) {
    $monitor   = shift @ARGV;
    $dectivate = shift @ARGV;
    $activate  = shift @ARGV;
} else {
    print("Invalid Arguments\n");
    exit(1);
}

$SQLmodeswitch = $dbh->prepare(q{
  update Zones set Type = ? where MonitorId = ? and Name like concat(?,"%")
});

$SQLmodeswitch->execute("Inactive",$monitor,$dectivate);
$SQLmodeswitch->execute("Active",$monitor,$activate);

system("$zmu -m $monitor -U $ZMuser -P $ZMpassword -L");
